// Copyright 1997, 1998 by Jon Dart.  All Rights Reserved.

#ifndef _PAWN_ENTRY_H
#define _PAWN_ENTRY_H

#include "types.h"
#include "bitmap.h"
#include "square.h"
#include "pool.h"
#include <malloc.h>

class Pawn_Entry
{
     // defines one entry in the pawn hash table.

public:

     Pawn_Entry()
     : hc(0xffffffff)
     {
     }

     // two entries are equivalent if they have the same hash code bytes.
     int is_equal( const Pawn_Entry &e) const
     {
         return hc == e.hc;
     }
	    
     hash_t hash_code() const
     {
        return hc;
     }
     
     hash_t hc; // hashcode

     struct PawnData {
        byte passers_count;
        Square passers[8];
        int score;
        int center_score;
        byte first_passer,last_passer;
        byte protected_pp;
        byte w_square_pawns,b_square_pawns;
        int weak_files;
        byte open_files;
        byte pawns_on_2nd_rank;
        byte outside;
        Bitmap opponent_pawn_attacks;
     };
     Pawn_Entry::PawnData w_pawn_entry;
     Pawn_Entry::PawnData b_pawn_entry;

};

#endif
