#ifndef _STATS_H
#define _STATS_H

#include "move.h"
#include "constant.h"

enum StateType {NormalState,Terminated,Check,Checkmate,
                Stalemate,Draw,Resigns};

// This structure holds information about a search
// after it has completed.
struct Statistics
{
   StateType state;
   int value;
   int display_value;
   Move best_line[Constants::MaxPly];
   char best_line_image[256];
   time_t elapsed_time; // in centiseconds
   unsigned depth;
   unsigned long num_moves;
   unsigned long num_nodes;
   unsigned long num_qnodes;
   int mvtot; // total root moves 
   int mvleft; // moves left to analyze at current depth
   long tb_probes; // tablebase probes
   long tb_hits;   // tablebase hits
   unsigned long futility_pruning;
   unsigned long num_null_cuts;
   unsigned long num_razored;
   unsigned long check_extensions, recap_extensions, threat_extensions,
     cap_extensions, pawn_extensions, forced_extensions;
   int move_order[4];
   int move_order_count;
   int end_of_game;
   Statistics();
   void clear();
};

#endif
